<template>
    <div>
        <form @submit.prevent="onSubmit">
            <div class="form-group col-md-12" :class="{'has-error': this.errors_centroCustos.name}">
                <label>Nome<b class="text-danger">*</b></label>
                <input type="text" class="form-control" v-model="formData.name">
                <label class="error" v-if="this.errors_centroCustos.name">{{errors_centroCustos.name[0]}}</label>
            </div>

            <div class="col-sm-12">
                <div class="hr-line-dashed"></div>
                <button class="btn btn-white" type="button" @click.prevent="backPage" :disabled="isBtnPreload">
                    <i class="fa fa-reply"></i> Voltar
                </button>
                <button class="btn btn-primary" type="submit" :disabled="isBtnPreload">
                    <i v-if="isBtnPreload" class="fa fa-circle-o-notch fa-spin"></i>
                    <i class="fa fa-save" v-else></i>
                    Salvar
                </button>
            </div>
        </form>
    </div>
</template>

<script>
    export default {
        props: {
            isUpdate: {
                require: false,
                type: Boolean,
                default: false,
            },

            formData: {
                require: false,
                type: Object,
                default: () => {
                    return {
                        name: '',
                    }
                }
            }
        },
        data() {
            return {
                errors_centroCustos: {
                    name: '',
                }
            }
        },

        computed: {
            isBtnPreload() {
                return this.$store.state.preload.btnLoading
            }
        },

        methods: {
            onSubmit() {
                const action = this.isUpdate ? 'updateCentroCusto' : 'storeCentroCusto'
                const msg = this.isUpdate ? 'Centro de custo editado com sucesso' :
                    'Cadastro de centro de custo feito com sucesso'
                this.$store.dispatch(action, this.formData)
                    .then(() => {
                        this.$snotify.success(msg)
                        this.$router.push({name: 'centro-custos'})
                    })
                    .catch((error) => {
                        this.errors_centroCustos = error.response.data.errors
                    })
            },

            backPage() {
                return this.$router.push({name: 'centro-custos'})
            }
        }
    }
</script>